
//#include "metalShaderTypes.h"

vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]])
{
    vertexOut out;

    out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}

vec4 grayscale (vec4 color)
{
    float gray=0.2126*color.r + 0.7152*color.g + 0.0722*color.b;
    return vec4(gray,gray,gray,color.a);
}


fragment float4 fragmentFunc(vertexOut in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]])
{
	vec4 texColor = tex(inputTex0,in.tex1);
	vec4 colorA=mix(vec4(0,0,0,0),texColor,u.mix);
	vec4 colorB=mix(texColor,vec4(0,0,0,0),u.mix);
	vec4 color1=mix(grayscale(colorA),colorA,smoothstep(.6,1.0,u.transitionProgress));
	vec4 color2=mix(grayscale(colorB),colorB,smoothstep(.6,1.0,1.0-u.transitionProgress));
	float4 outColor=mix(color2,color1,u.transitionProgress);
    outColor*=texColor.a;

#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif

	return outColor;
}
